unit Rrxrelat;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TabNotBk, StdCtrls, Buttons, ExtCtrls,RRX65;

type
  TRelationForm = class(TForm)
    MasterTableLabel: TLabel;
    MasterIndexLabel: TLabel;
    IndexTypeLabel: TLabel;
    AliasLabel: TLabel;
    TableLabel: TLabel;
    IndexLabel: TLabel;
    TagLabel: TLabel;
    MasterTableEdit: TEdit;
    MasterIndexEdit: TEdit;
    IndexTypeCombo: TComboBox;
    AliasCombo: TComboBox;
    TableEdit: TEdit;
    IndexEdit: TEdit;
    TagEdit: TEdit;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    MasterTableBtn: TSpeedButton;
    MasterIndexBtn: TSpeedButton;
    TableBtn: TSpeedButton;
    IndexBtn: TSpeedButton;
    Bevel1: TBevel;
    OpenDialog1: TOpenDialog;
    TableList: TListBox;
    IndexList: TListBox;
    TagList: TListBox;
    procedure MasterTableBtnClick(Sender: TObject);
    procedure TableBtnClick(Sender: TObject);
    procedure MasterIndexBtnClick(Sender: TObject);
    procedure TableEditChange(Sender: TObject);
    procedure IndexEditChange(Sender: TObject);
    procedure TagEditChange(Sender: TObject);
    procedure AliasComboChange(Sender: TObject);
    procedure IndexBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RelationForm: TRelationForm;

implementation

{$R *.DFM}


procedure TRelationForm.MasterTableBtnClick(Sender: TObject);
begin
  with opendialog1 do begin
    initialdir:=ExtractFilePath(MasterTableEdit.Text);
    Filter:='DBASE|*.DBF';
    Title:='Open Master Table';
    if execute then MasterTableEdit.Text:=filename;
    MasterTableEdit.SetFocus;
  end;
end;

procedure TRelationForm.TableBtnClick(Sender: TObject);
begin
 with opendialog1 do begin
   initialdir:=ExtractFilePath(TableEdit.Text);
    Filter:='DBASE|*.DBF';
    Title:='Open Table For Alias '+AliasCombo.Text;
    if execute then TableEdit.Text:=filename;
  end;
end;

procedure TRelationForm.MasterIndexBtnClick(Sender: TObject);
var
  OldExt:String;
begin
  with opendialog1 do begin
    initialdir:=ExtractFilePath(MasterIndexEdit.Text);
    filter:='FoxPro|*.CDX|FoxBASE+|*.IDX|dBASE IV|*.MDX|'+
                       'dBASE III|*.NDX|Clipper|*.NTX|SuccessWare|*.NSX|'+
                       'WordTech|*.WDX|All Files|*.*';

    { set default extension }
    OldExt:=ExtractFileExt(MasterIndexEdit.Text);
    FilterIndex:=8;
    if OldExt='.CDX' then FilterIndex:=1;
    if OldExt='.IDX' then FilterIndex:=2;
    if OldExt='.MDX' then FilterIndex:=3;
    if OldExt='.NDX' then FilterIndex:=4;
    if OldExt='.NTX' then FilterIndex:=5;
    if OldExt='.NSX' then FilterIndex:=6;
    if OldExt='.WDX' then FilterIndex:=7;

    Title:='Open Master Index ';
    if execute then MasterIndexEdit.Text:=filename;
    MasterIndexEdit.SetFocus;
  end;
end;

procedure TRelationForm.TableEditChange(Sender: TObject);
begin
  TableList.items[AliasCombo.ItemIndex]:=TableEdit.Text;
end;

procedure TRelationForm.IndexEditChange(Sender: TObject);
begin
 IndexList.items[AliasCombo.ItemIndex]:=IndexEdit.Text;
end;

procedure TRelationForm.TagEditChange(Sender: TObject);
begin
 TagList.items[AliasCombo.ItemIndex]:=TagEdit.Text;
end;

procedure TRelationForm.AliasComboChange(Sender: TObject);
begin
  TableEdit.Text:=TableList.items[AliasCombo.ItemIndex];
  IndexEdit.Text:=IndexList.items[AliasCombo.ItemIndex];
  TagEdit.Text:=TagList.items[AliasCombo.ItemIndex];
end;

procedure TRelationForm.IndexBtnClick(Sender: TObject);
var
  OldExt:String;
begin
 with opendialog1 do begin
    initialdir:=ExtractFilePath(IndexEdit.Text);
    filter:='FoxPro|*.CDX|FoxBASE+|*.IDX|dBASE IV|*.MDX|'+
                       'dBASE III|*.NDX|Clipper|*.NTX|SuccessWare|*.NSX|'+
                       'WordTech|*.WDX|All Files|*.*';

    { set default extension }
    OldExt:=ExtractFileExt(IndexEdit.Text);
    FilterIndex:=8;
    if OldExt='.CDX' then FilterIndex:=1;
    if OldExt='.IDX' then FilterIndex:=2;
    if OldExt='.MDX' then FilterIndex:=3;
    if OldExt='.NDX' then FilterIndex:=4;
    if OldExt='.NTX' then FilterIndex:=5;
    if OldExt='.NSX' then FilterIndex:=6;
    if OldExt='.WDX' then FilterIndex:=7;

    Title:='Open Index For Alias '+AliasCombo.Text;
    if execute then IndexEdit.Text:=filename;
    IndexEdit.SetFocus;
  end;
end;

end.
